import itertools

import math


def dis(p1, p2):
    return math.sqrt((p1[0] - p2[0]) ** 2 + (p1[1] - p2[1]) ** 2)


def s(n, p):
    mindis = float('inf')

    for perm in itertools.permutations(p):
        cdis = 0

        for i in range(n - 1):
            cdis += dis(perm[i], perm[i + 1])

        mindis = min(mindis, cdis)
    return mindis


n = int(input())
points = [tuple(map(int, input().split())) for _ in range(n)]

res = s(n, points)


print(f"{res:.6f}")
